// MyToday1.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "Svatky.h"

LPCTSTR g_lpcszClass = _T("SvatkyWndClass");
LPCTSTR g_lpcszWnd = _T("SvatkyWnd");
HWND g_mainWnd = NULL;
HINSTANCE g_hInstance = NULL;

// Icons to draw
HICON g_hAppIcon = NULL;

// Default settings for today fonts and texts
COLORREF g_crTodayText = NULL;
HFONT g_fontTodayBold = NULL;

// nazvy dnu
TCHAR *dny[] = {_T("NE"), _T("PO"),_T("T"),_T("ST"),_T("T"),_T("P"),_T("SO")};
// nazvy mesicu
TCHAR *mesice[] = {_T("ledna"), _T("nora"),_T("bezna"),_T("dubna"),_T("kvtna"),_T("ervna"),_T("ervence"),_T("srpna"),_T("z"),_T("jna"),_T("listopadu"),_T("prosince")};
// pozice zacatku mesicu v souboru svatku
int startIndexes[] = {0, 31, 60, 91, 121, 152, 182, 213, 244, 274, 305, 335};

// text, ktery se vypisuje na obrazovku
TCHAR g_text[100];

// citac pro obnovovani obsahu
int g_counter = 0;
// za kolik zprav WM_TODAYCUSTOM_QUERYREFRESHCACHE se bude kontrolovat datum
int POOL_INTERVAL = 5;
// stara hodnota cisla dne, slouzi pro detekci zmeny data
WORD g_oldDay = 0;

BOOL APIENTRY DllMain(HANDLE hModule, DWORD dwReason, LPVOID lpReserved)
{
	if (dwReason == DLL_PROCESS_ATTACH)
	{
		// Just remember DLL instance
		g_hInstance = (HINSTANCE)hModule;

		// Unregister today window class
		UnregisterClass(g_lpcszClass, (HINSTANCE)hModule);

		// Register today window class
		WNDCLASS wndClass;
		memset(&wndClass, 0, sizeof(wndClass));
		wndClass.hCursor = 0;
		wndClass.hIcon = 0;
		wndClass.hInstance = (HINSTANCE)hModule;
		wndClass.lpszClassName = g_lpcszClass;
		wndClass.lpszMenuName = NULL;
		wndClass.style = CS_VREDRAW | CS_HREDRAW;
		wndClass.hbrBackground = (HBRUSH)GetStockObject(HOLLOW_BRUSH);
		wndClass.lpfnWndProc = WndProc;

		RegisterClass(&wndClass);
	}
	else if (dwReason == DLL_PROCESS_DETACH)
	{
		// Destroy all allocated variables

		if (g_fontTodayBold)
			DeleteObject(g_fontTodayBold);

		if (g_hAppIcon)
			DeleteObject(g_hAppIcon);
	}

    return TRUE;
}

void GetTodayDefaults(HWND hWndParent)
{
	g_crTodayText = SendMessage(hWndParent, TODAYM_GETCOLOR, (WPARAM)TODAYCOLOR_TEXT, NULL);

	LOGFONT lf;
	HFONT hSysFont;

	// Default today fonts
	hSysFont = (HFONT)GetStockObject(SYSTEM_FONT);
	GetObject(hSysFont, sizeof(LOGFONT), &lf);

	HDC hdc = GetDC(g_mainWnd);

	lstrcpy(lf.lfFaceName, _T("Tahoma"));
	lf.lfHeight = -1 * (17 * GetDeviceCaps(hdc, LOGPIXELSY) / 72) / 2;

	ReleaseDC(g_mainWnd, hdc);

	// Bold text
	lf.lfWeight = FW_BOLD;
	g_fontTodayBold = CreateFontIndirect(&lf);
}

void LoadIcons()
{
	// Load app icon which will be drawn on the left of today item
	g_hAppIcon = (HICON)LoadImage(g_hInstance, MAKEINTRESOURCE(ID_APP_ICO), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);
}

HWND APIENTRY InitializeCustomItem(TODAYLISTITEM *ptli, HWND hWndParent)
{
	// Check if item's enabled
	if (!ptli->fEnabled)
		return 0;

	// Set zero initial height
	ptli->cyp = 0;

	// Create window itself, with desired style
	// Again set its zero height
	g_mainWnd = CreateWindow(g_lpcszClass, g_lpcszWnd, WS_CHILD | WS_VISIBLE,
		                     // Set correct size
		                     0, 0, GetSystemMetrics(SM_CXSCREEN), 0,
							 hWndParent, NULL, ptli->hinstDLL, NULL);

	if (!g_mainWnd)
		return 0;

	// Get defaults for today screen
	GetTodayDefaults(hWndParent);

	// Load all icons needed
	LoadIcons();

	return g_mainWnd;
}

// zjisti jmeno dne podle cisla mesice a cisla dne
TCHAR *nameDay(int month, int day) {
	int index = startIndexes[month - 1] + day;
	TCHAR *buffer = (TCHAR*) malloc(sizeof(TCHAR)*128);

	FILE *input;
	if ((input = fopen("\\Windows\\svatky.txt","rb")) == NULL) {
		MessageBox(NULL, TEXT("Nelze otevt vstupn soubor"), TEXT("Chyba"), MB_OK | MB_ICONERROR);
		return NULL;
	}

	for (int i = 0; i < index; i++) {
		fgetws(buffer, 127, input);
	}

	buffer[wcslen(buffer)-2]=0;


	fclose(input);


	return buffer;
}

void DoPaint(HDC hDC)
{
	HFONT hFontOld;
	RECT rect;
	SIZE size;
	TCHAR *lpszText = (TCHAR*)malloc(MAX_PATH);

	// Set transparent background
	SetBkMode(hDC, TRANSPARENT);
	// Set font color to Today text one
	SetTextColor(hDC, g_crTodayText);

	// Draw Today item icon
	if (g_hAppIcon)
		DrawIcon(hDC, 2, 1, g_hAppIcon);

	//szText = _T("First line - bold font");
	hFontOld = (HFONT)SelectObject(hDC, g_fontTodayBold);

	GetTextExtentPoint32(hDC, g_text, _tcslen(g_text), &size);
	rect.left = 30;
	rect.top = 2;
	rect.right = rect.left + size.cx;
	rect.bottom = size.cy+2;

	DrawText(hDC, g_text, -1, &rect, DT_LEFT);

	SelectObject(hDC, hFontOld);
	
}

void updateText(SYSTEMTIME systemTime) {
	swprintf(g_text, _T("%s, %d. %s %d, %s"), dny[systemTime.wDayOfWeek], systemTime.wDay, mesice[systemTime.wMonth-1], systemTime.wYear, nameDay(systemTime.wMonth,systemTime.wDay));
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{	
	switch (uMsg)
	{
	case WM_CREATE:
		{
			SYSTEMTIME systemTime;
			GetLocalTime(&systemTime);
			g_oldDay = systemTime.wDay;
			updateText(systemTime);
		}
	case WM_PAINT :
		{
            PAINTSTRUCT ps;
            HDC hDC;

            hDC = BeginPaint(hWnd, &ps);

			// Draw Today Item
			DoPaint(hDC);

			EndPaint(hWnd, &ps);
		}

		break;
	case WM_ERASEBKGND :
		{
			HDC hDC = (HDC)wParam;
			TODAYDRAWWATERMARKINFO dwi;

			dwi.hdc = hDC;
			GetClientRect(hWnd, &dwi.rc);
			
			dwi.hwnd = hWnd;

			SendMessage(GetParent(hWnd), TODAYM_DRAWWATERMARK, 0, (LPARAM)&dwi);

			return TRUE;
		}
	case WM_TODAYCUSTOM_CLEARCACHE :
		{
			TODAYLISTITEM *ptli = (TODAYLISTITEM *)wParam;

			return FALSE;
		}
	case WM_TODAYCUSTOM_QUERYREFRESHCACHE :
		{

			TODAYLISTITEM *ptli = (TODAYLISTITEM *)wParam;

			if (ptli->cyp == 0)
			{
				ptli->cyp = 38;
				return TRUE;
			}

			g_counter++;

			if (g_counter % POOL_INTERVAL) {
				SYSTEMTIME systemTime;
				GetLocalTime(&systemTime);
		
				if (g_oldDay != systemTime.wDay) { // doslo ke zmene data
					g_oldDay = systemTime.wDay;
					updateText(systemTime);

					return TRUE;
				}
			
			}


			return FALSE;
		}
	case WM_LBUTTONUP :
		{
			// Bylo kliknuto na plochu, spustime nastavovani casu
			PROCESS_INFORMATION pi;

			::CreateProcess(_T("\\Windows\\ctlpnl.exe"), _T("cplmain.cpl,16"), NULL, NULL, FALSE, 0, NULL, NULL, NULL, &pi);

			return 0;
		}
	}

	return DefWindowProc(hWnd, uMsg, wParam, lParam);
}